{% extends "base-site.html" %}

{% block title %} Dashboard {% endblock %} 

<!-- Specific Page CSS goes HERE  -->
{% block stylesheets %}{% endblock stylesheets %}

<script src="https://code.jquery.com/ui/1.12.0/jquery-ui.min.js" integrity="sha256-eGE6blurk5sHj+rmkfsGYeKyZx3M4bG+ZlFyA7Kns7E=" crossorigin="anonymous"></script>
  

{% block content %}


<div class="row">
  <div id="toolbar-options" class="hidden">
    <a id="option-transaction-remove" href="#"><i class="fa fa-trash"></i></a>
    <a id="option-transaction-edit" href="#"><i class="fa fa-edit"></i></a>
 </div>

<!-- Dialog-->
 <div id="dialog-remove-transaction" title="Delete transaction?" class="hidden">
  <p style="color: black;"><span class="ui-icon ui-icon-alert" style="float:left; margin:12px 12px 20px 0; color:black;"></span>These transaction will be permanently deleted and cannot be recovered. Are you sure?</p>
</div>


<!-- Modal -->
<div class="modal modal-black fade" id="popupFormTransaction" tabindex="-1" role="dialog" aria-labelledby="popupFormTransactionTitle" aria-hidden="true">
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h1 class="modal-title" id="popupFormTransactionTitle">New transaction</h1>
        <button type="button" class="close" data-dismiss="modal" aria-hidden="true">
          <i class="tim-icons icon-simple-remove"></i>
        </button>
      </div>
      <form method="post">    
      <div class="modal-body">
          <input type="hidden" class="form-control" name="transaction_marker">
          <!-- Title -->
          <label for="transaction_title">
          <strong>Title</strong>
          </label>
          <input type="text" class="form-control" placeholder="Title" name="transaction_title">
          <!-- Category -->
          <label for="transaction_category">
            <strong>Category</strong>
          </label>
          <select class="form-control" name="transaction_category">
           {% for item in category_list %}
            <option style="background-color: #1e1e2f" value="{{ item }}">{{ item }}</option>
           {% endfor %}
          </select>
          <!-- Value -->
          <label for="transaction_value">
            <strong>Value (€)</strong>
          </label>
          <input type="number" class="form-control" step="0.10" placeholder="0.00" name="transaction_value">
          <!-- Comment -->
          <label for="transaction_comment">
            <strong>Comment</strong>
          </label>
          <input type="text" class="form-control"placeholder="Comment" name="transaction_comment">
          <!-- Date -->
          <label for="transaction_date">
            <strong>Date</strong>
          </label>
          <input id="transaction_date" type="text" class="form-control" placeholder="01.01.2020" name="transaction_date"  autocomplete="off">
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
        <input type="reset" value="Clear" class="btn btn-secondary">
        <input type="submit"  value="Save" onclick="$('#popupFormTransaction').modal('hide'); balance.showNotification('top','right', 'Sending transaction to server...', 'edit', 1500); setTimeout(function() {update_values();}, 3000);" class="btn btn-primary">
      </div>
      </form>
    </div>
  </div>
</div>

<!-- Modal -->
<div class="modal modal-black  fade" id="popupFormUpdateTransaction" tabindex="-1" role="dialog" aria-labelledby="popupFormUpdateTransactionTitle" aria-hidden="true">
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h1 class="modal-title" id="popupFormUpdateTransactionTitle">Update transaction</h1>
        <button type="button" class="close" data-dismiss="modal" aria-hidden="true">
          <i class="tim-icons icon-simple-remove"></i>
        </button>
      </div>
      <form method="post">    
      <div class="modal-body">
        <input type="hidden" class="form-control" name="transaction_update_marker">
        <input type="hidden" class="form-control" id="transaction_id_update" name="transaction_id">
        <!-- Title -->
        <label for="transaction_title">
        <strong>Title</strong>
        </label>
        <input type="text" class="form-control" placeholder="Title" id="transaction_title_update" name="transaction_title">
        <!-- Category -->
        <label for="transaction_category">
          <strong>Category</strong>
        </label>
        <select class="form-control" id="transaction_category_update" name="transaction_category">
        {% for item in category_list %}
          <option  style="background-color: #1e1e2f" value="{{ item }}">{{ item }}</option>
        {% endfor %}
        </select>
        <!-- Value -->
        <label for="transaction_value">
          <strong>Value (€)</strong>
        </label>
        <input type="number" class="form-control" step="0.10" placeholder="0.00" id="transaction_value_update" name="transaction_value">
        <!-- Comment -->
        <label for="transaction_comment">
          <strong>Comment</strong>
        </label>
        <input type="text" class="form-control" placeholder="Comment" id="transaction_comment_update" name="transaction_comment">
        <!-- Date -->
        <label for="transaction_date">
          <strong>Date</strong>
        </label>
        <input type="text" class="form-control" placeholder="01.01.2020" id="transaction_date_update" name="transaction_date"  autocomplete="off">      
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
        <input type="reset" value="Clear" class="btn btn-secondary">
        <input type="submit" value="Save" onclick="$('#popupFormUpdateTransaction').modal('hide'); balance.showNotification('top','right', 'Updating transaction...', 'edit', 1500); setTimeout(function() {update_values();}, 3000);" class="btn btn-primary">
      </div>
      </form>
    </div>
  </div>
</div>

<!-- Modal -->
<div class="modal modal-black  fade" id="popupFormCategory" tabindex="-1" role="dialog" aria-labelledby="popupFormCategoryTitle" aria-hidden="true">
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h1 class="modal-title" id="popupFormCategoryTitle">New category</h1>
        <button type="button" class="close" data-dismiss="modal" aria-hidden="true">
          <i class="tim-icons icon-simple-remove"></i>
        </button>
      </div>
      <form method="post">    
      <div class="modal-body">
        <input type="hidden" class="form-control" placeholder="0.00" name="category_marker">

        <!-- Name -->
        <label for="category_name">
        <strong>Name</strong>
        </label>
        <input type="text" class="form-control" placeholder="Name" name="category_name">
        <!-- Description -->
        <label for="category_description">
          <strong>Description</strong>
        </label>
        <input type="text" class="form-control" placeholder="Description" name="category_description">
        <!-- Icon -->
        <label for="category_icon">
          <strong>Icon</strong>
        </label>
        <input id="category-icon-picker" type="text" class="form-control" placeholder="Icon" name="category_icon">
        <br/>
        <div style="text-align: center;" >
            <a><i id="category-icon-picker-preview" class="fa fa-question fa-fw fa-2x"></i></a>
        </div>
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
        <input type="reset" value="Clear" class="btn btn-secondary">
        <input type="submit" value="Save" onclick="$('#popupFormCategory').modal('hide'); balance.showNotification('top','right', 'Updating transaction...', 'plus', 1500); setTimeout(function() {update_values();}, 3000);" class="btn btn-primary">
      </div>
      </form>
    </div>
  </div>
</div>

<!-- Modal -->
<div class="modal modal-black fade" id="popupFormShares" tabindex="-1" role="dialog" aria-labelledby="popupFormSharesTitle" aria-hidden="true">
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h1 class="modal-title" id="popupFormSharesTitle">New share type</h1>
        <button type="button" class="close" data-dismiss="modal" aria-hidden="true">
          <i class="tim-icons icon-simple-remove"></i>
        </button>
      </div>
      <form method="post">    
      <div class="modal-body">
          <input type="hidden" class="form-control" name="share_marker">
          <!-- Name -->
          <label for="share_name">
          <strong>Name</strong>
          </label>
          <input type="text" class="form-control" placeholder="Name" name="share_name">
          <!-- Ticker -->
          <label for="share_ticker">
            <strong>Ticker</strong>
          </label>
          <input type="text" class="form-control"placeholder="Ticker" name="share_ticker">
          <!-- Date -->
          <label for="share_isin">
            <strong>ISIN</strong>
          </label>
          <input type="text" class="form-control"placeholder="ISIN" name="share_isin">
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
        <input type="reset" value="Clear" class="btn btn-secondary">
        <input type="submit"  value="Save" onclick="$('#popupFormShares').modal('hide'); balance.showNotification('top','right', 'Sending share to server...', 'edit', 1500);" class="btn btn-primary">
      </div>
      </form>
    </div>
  </div>
</div>

<!-- Modal -->
<div class="modal modal-black fade" id="popupFromSharePosition" tabindex="-1" role="dialog" aria-labelledby="popupFormSharePositionTitle" aria-hidden="true">
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h1 class="modal-title" id="popupFormSharePositionTitle">Open new share position</h1>
        <button type="button" class="close" data-dismiss="modal" aria-hidden="true">
          <i class="tim-icons icon-simple-remove"></i>
        </button>
      </div>
      <form method="post">    
      <div class="modal-body">
          <input type="hidden" class="form-control" name="share_position_marker">
          <!-- Category -->
          <label for="share_position_transaction_category">
            <strong>Category</strong>
          </label>
          <select class="form-control" name="share_position_transaction_category">
           {% for category in category_list %}
            <option style="background-color: #1e1e2f" value="{{ category }}">{{ category }}</option>
           {% endfor %}
          </select>
          <!-- Value -->
          <label for="share_position_transaction_value">
            <strong>Value (€)</strong>
          </label>
          <input type="number" class="form-control" step="0.10" placeholder="0.00" name="share_position_transaction_value">
          <!-- Share -->
          <label for="share_position_share_type">
            <strong>Share type</strong>
          </label>
          <select class="form-control" name="share_position_share_type">
           {% for share in share_type_list %}
            <option style="background-color: #1e1e2f" value="{{ share }}">{{ share }}</option>
           {% endfor %}
          </select>
          <!-- Amount -->
          <label for="share_position_amount">
            <strong>Amount of shares</strong>
          </label>
          <input type="number" class="form-control" step="0.10" placeholder="0.00" name="share_position_amount">
          <!-- Comment -->
          <label for="share_position_transaction_comment">
            <strong>Comment</strong>
          </label>
          <input type="text" class="form-control"placeholder="Comment" name="share_position_transaction_comment">
          <!-- Date -->
          <label for="share_position_transaction_date">
            <strong>Date</strong>
          </label>
          <input id="share_position_transaction_date" type="text" class="form-control" placeholder="01.01.2020" name="share_position_transaction_date"  autocomplete="off">
          <!-- Depot -->
          <label for="share_position_depot">
            <strong>Depot</strong>
          </label>
          <input type="text" class="form-control"placeholder="Depot" name="share_position_depot">

      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
        <input type="reset" value="Clear" class="btn btn-secondary">
        <input type="submit"  value="Save" onclick="$('#popupFromSharePosition').modal('hide'); balance.showNotification('top','right', 'Sending position to server...', 'edit', 1500);" class="btn btn-primary">
      </div>
      </form>
    </div>
  </div>
</div>

<!-- Modal -->
<div class="modal modal-black fade" id="popupFormCoins" tabindex="-1" role="dialog" aria-labelledby="popupFormCoinsTitle" aria-hidden="true">
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h1 class="modal-title" id="popupFormCoinsTitle">New coin type</h1>
        <button type="button" class="close" data-dismiss="modal" aria-hidden="true">
          <i class="tim-icons icon-simple-remove"></i>
        </button>
      </div>
      <form method="post">    
      <div class="modal-body">
          <input type="hidden" class="form-control" name="coin_marker">
          <!-- Name -->
          <label for="coin_name">
          <strong>Name</strong>
          </label>
          <input type="text" class="form-control" placeholder="Name" name="coin_name">
          <!-- Ticker -->
          <label for="coin_ticker">
            <strong>Ticker</strong>
          </label>
          <input type="text" class="form-control"placeholder="Ticker" name="coin_ticker">
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
        <input type="reset" value="Clear" class="btn btn-secondary">
        <input type="submit"  value="Save" onclick="$('#popupFormCoins').modal('hide'); balance.showNotification('top','right', 'Sending new coin type to server...', 'edit', 1500);" class="btn btn-primary">
      </div>
      </form>
    </div>
  </div>
</div>

<!-- Modal -->
<div class="modal modal-black fade" id="popupFromCoinPosition" tabindex="-1" role="dialog" aria-labelledby="popupFromCoinPositionTitle" aria-hidden="true">
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h1 class="modal-title" id="popupFromCoinPositionTitle">Open new coin position</h1>
        <button type="button" class="close" data-dismiss="modal" aria-hidden="true">
          <i class="tim-icons icon-simple-remove"></i>
        </button>
      </div>
      <form method="post">    
      <div class="modal-body">
          <input type="hidden" class="form-control" name="coin_position_marker">
          <!-- Category -->
          <label for="coin_position_transaction_category">
            <strong>Category</strong>
          </label>
          <select class="form-control" name="coin_position_transaction_category">
           {% for category in category_list %}
            <option style="background-color: #1e1e2f" value="{{ category }}">{{ category }}</option>
           {% endfor %}
          </select>
          <!-- Value -->
          <label for="coin_position_transaction_value">
            <strong>Value (€)</strong>
          </label>
          <input type="number" class="form-control" step="0.10" placeholder="0.00" name="coin_position_transaction_value">
          <!-- Coin -->
          <label for="coin_position_coin_type">
            <strong>Coin type</strong>
          </label>
          <select class="form-control" name="coin_position_coin_type">
           {% for coin in coin_type_list %}
            <option style="background-color: #1e1e2f" value="{{ coin }}">{{ coin }}</option>
           {% endfor %}
          </select>
          <!-- Amount -->
          <label for="coin_position_amount">
            <strong>Amount of coins</strong>
          </label>
          <input type="number" class="form-control" step="0.10" placeholder="0.00" name="coin_position_amount">
          <!-- Comment -->
          <label for="coin_position_transaction_comment">
            <strong>Comment</strong>
          </label>
          <input type="text" class="form-control"placeholder="Comment" name="coin_position_transaction_comment">
          <!-- Date -->
          <label for="coin_position_transaction_date">
            <strong>Date</strong>
          </label>
          <input id="coin_position_transaction_date" type="text" class="form-control" placeholder="01.01.2020" name="coin_position_transaction_date"  autocomplete="off">
          <!-- Depot -->
          <label for="coin_position_exchange">
            <strong>Exchange</strong>
          </label>
          <input type="text" class="form-control"placeholder="Exchange" name="coin_position_exchange">

      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
        <input type="reset" value="Clear" class="btn btn-secondary">
        <input type="submit"  value="Save" onclick="$('#popupFromCoinPosition').modal('hide'); balance.showNotification('top','right', 'Sending position to server...', 'edit', 1500);" class="btn btn-primary">
      </div>
      </form>
    </div>
  </div>
</div>

  <div class="col-12">
    <div class="grid-stack">
      
    </div>
  </div>
  



{% endblock content %}

<!-- Specific Page JS goes HERE  -->
{% block javascripts %}

<script>
    var global_transaction_dict = {}
    var api_server_uri = {{ request.script_root|tojson|safe }};

    // Icon picker
    $('#category-icon-picker').on('input', function() {
      $('#category-icon-picker-preview').removeClass();
      var selected_icon = 'fa fa-' + $('#category-icon-picker').val() + ' fa-fw fa-2x'
      $('#category-icon-picker-preview').addClass(selected_icon)
    });

    datepickers = ['coin_position_transaction_date', 'share_position_transaction_date', 'transaction_date', 'transaction_date_update']
    datepickers.forEach(function(datepicker_id){
      $('#' + datepicker_id).datepicker({
       prevText: '&#x3c;Back', prevStatus: '',
        prevJumpText: '&#x3c;&#x3c;', prevJumpStatus: '',
        nextText: 'Next&#x3e;', nextStatus: '',
        nextJumpText: '&#x3e;&#x3e;', nextJumpStatus: '',
        currentText: 'today', currentStatus: '',
        todayText: 'today', todayStatus: '',
        clearText: '-', clearStatus: '',
        closeText: 'close', closeStatus: '',
        monthNames: ['January','February','March','April','May','June',
        'July','August','September','October','November','December'],
        monthNamesShort: ['Jan','Feb','Mar','Apr','May','Jun',
        'Jul','Aug','Sep','Okt','Nov','Dec'],
        dayNames: ['Sonntag','Montag','Dienstag','Mittwoch','Donnerstag','Freitag','Samstag'],
        dayNamesShort: ['So','Mo','Di','Mi','Do','Fr','Sa'],
        dayNamesMin: ['So','Mo','Di','Mi','Do','Fr','Sa'],
      showMonthAfterYear: false,
      dateFormat:'dd.mm.yy'
    } 
  );
  });
   
    // Grid
    var grid = GridStack.init({
      resizable: {
        handles: 'e, se, s, sw, w'
      },
      disableOneColumnMode: true,
      float: true
    });
    
    grid.on('added removed change', function(e, items) {
      var str = '';
      items.forEach(function(item) { str += ' (x,y)=' + item.x + ',' + item.y; });
      console.log(e.type + ' ' + items.length + ' items:' + str );
    });



    // Load settings for all required widgets
    widgets.init(api_server_uri)
    widgets.create_widget(grid, 'WidgetAccountOverview')
    widgets.create_widget(grid, 'WidgetTimeline')
    widgets.create_widget(grid, 'WidgetBalanceChart')
    widgets.create_widget(grid, 'WidgetControlPanel')
    widgets.create_widget(grid, 'WidgetTabelOverview')
    widgets.create_widget(grid, 'WidgetTransactionChart')
    widgets.create_widget(grid, 'WidgetShareOverview')
    widgets.create_widget(grid, 'WidgetCoinOverview')


    function zip(arrays) {
            return arrays[0].map(function(_,i){
                return arrays.map(function(array){return array[i]})
            });
            }

    // TODO: switch jquery-ui out
    $('.newWidget').draggable({
      revert: 'invalid',
      scroll: false,
      appendTo: 'body',
      helper: 'clone'
    });

    // Charts
   
    // Transactions
    /*
    function update_values() {
            balance.showNotification('top','right', 'Refreshing interface', 'cloud-download-alt', 3000);
            var api_server_uri = {{ request.script_root|tojson|safe }};
            update.updateTransactionTable(api_server_uri)
            update.updateTransactionChart(api_server_uri)
            update.updateBalanceChart(api_server_uri)
            update.updateTimeline(api_server_uri)
            update.updateOverview(api_server_uri)
        }

    update_values()
  
    */

</script>

{% endblock javascripts %}